/*
 * @(#)init.c	1.10 Aug.24,1993
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * (C) yamasita@omronsoft.co.jp
 */

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<signal.h>
#ifdef	SIGWINCH
#include	<sys/ioctl.h>
#endif

#ifdef NECODT
#include	<sys/stream.h>
#include	<sys/ptem.h>
#include	<sys/termio.h>
#endif	/* NECODT */

#ifdef MSDOS
#include	<stdlib.h>
#include	<string.h>
#else
#include	<pwd.h>
extern unsigned char	*getenv();
extern unsigned char	*malloc();
extern unsigned char	*strchr();
#endif

#include	"nntp.h"
#include	"gn.h"

extern unsigned char *kb_input();

static unsigned char *mail_lang = 0;
static unsigned char *process_lang = 0;
static unsigned char *file_lang = 0;
static unsigned char *display_lang = 0;

struct env_t {
	char *str;
	unsigned char **value;
};
static struct env_t env_table[] = {
	{ "TMPDIR",		&tmpdir },			/* ƥݥǥ쥯ȥ */
	{ "SAVEDIR",	&savedir },			/* ¸ǥ쥯ȥ */
	{ "PAGER",		&pager },			/* ڡ */
	{ "EDITOR",		&editor },			/* ǥ */
#ifndef	MSDOS
	{ "MAILER",		&mailer },			/* ᥤ */
#endif
	{ "NNTPSERVER",	&nntpserver },		/* ˥塼 */
	{ "DOMAINNAME",	&domainname },		/* ɥᥤ̾ */
	{ "ORGANIZATION",&organization },	/* ȿ̾ */
	{ "NAME",		&fullname },		/* Full Name */
	{ "NEWSRC",		&rcfile },			/* .newsrc */
	{ "SIGNATURE",	&signature },		/* .signature */
	{ "AUTHOR_COPY",&author_copy },		/* author_copy */
	{ "MAIL_LANG",	&mail_lang },		/* ᥤδ */
	{ "PROCESS_LANG",&process_lang },	/* ڡ㡿ǥδ */
	{ "FILE_LANG",	&file_lang },		/* եδ */
	{ "DISPLAY_LANG",	&display_lang },/* ǥץ쥤δ */
#ifdef	MSDOS
	{ "USER",		&usrname },
	{ "LOGNAME",	&usrname },
	{ "HOST",		&hostname },		/* ۥ̾ */
	{ "SMTPSERVER",	&smtpserver },		/* smtp,pop3|ftp  */
	{ "TMP",		&tmpdir },			/* ƥݥǥ쥯ȥ */
	{ "TEMP",		&tmpdir },			/* ƥݥǥ쥯ȥ */
#endif
	{ 0,0 }
	};
struct lang_t {
	char *str;
	int value;
};
static struct lang_t lang_table[] = {
	{"JIS",			JIS},
	{"C",			JIS},
	{"japanese",	JIS},
	{"ja_JP.jis7",	JIS},
	{"ja_JP.jis8",	JIS},
	{"ja_JP.pjis",	JIS},
	{"ja_JP.jis",	JIS},
	{"wr_WR.ct",	JIS},
	{"wr_WR.junet",	JIS},

	{"EUC",			EUC},
	{"UJIS",		EUC},
	{"ja_JP.ujis",	EUC},
	{"ja_JP.euc",	EUC},

	{"SJIS",		SJIS},
	{"ja_JP.sjis",	SJIS},
	{"ja_JP.mscode",SJIS},
	{0,0 }
};
struct gnrc_t {
	char *str;
	int *value;
};
static struct gnrc_t gnrc_table[] = {
	{ "ARTICLE_LIMIT",	&article_limit },
	{ "ARTICLE_LEAVE",	&article_leave },
	{ "GNUS_FORMAT",	&gnus_format },
	{ "NSUBJECT",		&nsubject },
	{ "DESCRIPTION",	&description },
	{ "KILL_CANCEL",	&kill_control },	/* upper compatible */
	{ "KILL_CONTROL",	&kill_control },
	{ "GENERICFROM",	&genericfrom },
	{ "AUTOLIST",		&autolist },
	{ "RETURN_AFTER_PAGER",		&return_after_pager },
	{ 0,0 }
};

#ifdef	SIGWINCH
static resize_window();
#endif
#ifdef	SIGCONT
static foreground();
#endif
static void read_gnrc(),newsrc_gnus_count(),
	newsrc_kill_article();

gn_init(argc,argv)
int	argc;
unsigned char *argv[];
{
	extern unsigned char *optarg;
	extern unsigned char *version;
	extern unsigned char *date;
	extern int	optind;
#ifdef	SIGWINCH
	extern int resize_window();
#endif
#ifdef	SIGCONT
	extern int foreground();
#endif
	extern unsigned char *expand_filename();

	int	c;
	register unsigned char *env,*gnrc;
	unsigned char resp[NNTP_STRLEN+1];
	unsigned char home[NNTP_STRLEN+1];
	struct stat stat_buf;
	int	check_only = CONT;
	register struct env_t *env_tp;
	register struct lang_t *lang_tp;
	unsigned char *pt,*sp;
	unsigned char full_name[MAXNAME];
	unsigned char host_name[MAXHOSTNAME+1];

#ifndef	MSDOS
	struct	passwd *pw,*getpwnam();
#endif
	if ( (env = getenv("HOME")) != 0 )
		strcpy(home,env);
	else
		strcpy(home,SLASH_STR);
#ifdef	MSDOS
	while ( (pt = strchr(home,'/')) != NULL )
		*pt = SLASH_CHAR;
#endif

#if defined(MSDOS) && ( defined(INETBIOS) || defined(PATHWAY) )
	if( find_inet() == 0 ) {
		mc_puts("BIOS󤷤Ƥޤ\n");
		exit(1);
	}
#endif

	/* ̹Կ */
	if ((env = getenv("LINES")) != 0)
		lines=atoi(env);

	/* ̷ */
	if ((env = getenv("COLUMNS")) != 0)
		columns=atoi(env);

#ifdef	SIGWINCH
	signal(SIGWINCH, resize_window);
	resize_window();
#endif

	/* $HOME/.gnrc β */
#ifdef	MSDOS
	gnrc = expand_filename("gnrc",home);
#else
	gnrc = expand_filename(".gnrc",home);
#endif
	read_gnrc(gnrc);

	/* Ķѿβ */
	for ( env_tp = &env_table[0] ; env_tp->str != 0 ; env_tp++ ) {
		if ((env = getenv(env_tp->str)) != 0) {
			if ( *(env_tp->value) != 0 )
				free(*(env_tp->value));
			*(env_tp->value) = malloc(strlen(env)+1);
			strcpy(*(env_tp->value),env);
		}
	}

	/* ưץβ */
	while ((c = getopt(argc, argv, "h:d:ngV")) != EOF) {
		switch (c) {
		case 'h':				/* ˥塼Фꤹ */
			free(nntpserver);
			nntpserver = malloc(strlen(optarg)+1);
			strcpy(nntpserver,optarg);
			break;
		case 'd':				/* ɥᥤ̾ꤹ */
			free(domainname);
			domainname = malloc(strlen(optarg)+1);
			strcpy(domainname,optarg);
			break;
		case 'V':
			printf("gn Version %s %s.   (C) yamasita@omronsoft.co.jp\n",
				   version,date);
			break;
		case 'g':
			gnus_format = 1;
			break;
		case 'n':
			check_only = QUIT;
			break;
		default:
			printf("%s [-h hostname] [-d domainname][-gnV]\n",argv[0]);
			mc_puts("   -h hostname   ˥塼Фꤹ\n");
			mc_puts("   -d domainname ɥᥤ̾ꤹ\n");
			mc_puts("   -g            GNUS ȶ̤ .newsrc եޥåȤѤ\n");
			mc_puts("   -n            ̤ɤεɽƽλ\n");
			mc_puts("   -V            Сɽ\n");
			exit(5);
		}
	}

	/* .gnrc-NNTPSERVER */
#ifdef	MSDOS
	strcpy(resp,"gnrc-");
#else
	strcpy(resp,".gnrc-");
#endif
	strcat(resp,nntpserver);
	gnrc = expand_filename(resp,home);
	if ( stat(gnrc,&stat_buf) == 0 ) {
		read_gnrc(gnrc);
	} else {
#ifdef	MSDOS
		strcpy(resp,"gnrc.");
#else
		strcpy(resp,".gnrc.");
#endif
		strcat(resp,nntpserver);
		gnrc = expand_filename(resp,home);
		read_gnrc(gnrc);
	}

	/*  */
	if ( mail_lang != 0 ) {
		for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
			if (strcmp(lang_tp->str,mail_lang) == 0 ) {
				mail_kanji_code = lang_tp->value;
				break;
			}
		}
	}
	if ( process_lang != 0 ) {
		for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
			if (strcmp(lang_tp->str,process_lang) == 0 ) {
				process_kanji_code = lang_tp->value;
				break;
			}
		}
	}
	if ( file_lang != 0 ) {
		for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
			if (strcmp(lang_tp->str,file_lang) == 0 ) {
				file_kanji_code = lang_tp->value;
				break;
			}
		}
	}
	if ( display_lang != 0 ) {
		for ( lang_tp = &lang_table[0] ; lang_tp->str != 0 ; lang_tp++ ) {
			if (strcmp(lang_tp->str,display_lang) == 0 ) {
				display_kanji_code = lang_tp->value;
				break;
			}
		}
	}

	/* .newsrc_NNTPSERVER */
	env = expand_filename(rcfile,home);
	strcpy(resp,env);
	strcat(resp,"_");
	strcat(resp,nntpserver);
	if ( stat(resp,&stat_buf) == 0 ) {
		rcfile = malloc(strlen(resp)+1);
		strcpy(rcfile,resp);
	} else {
		strcpy(resp,env);
		strcat(resp,"-");
		strcat(resp,nntpserver);
		if ( stat(resp,&stat_buf) == 0 ) {
			rcfile = malloc(strlen(resp)+1);
			strcpy(rcfile,resp);
		} else {
			strcpy(resp,env);
			strcat(resp,".");
			strcat(resp,nntpserver);
			if ( stat(resp,&stat_buf) == 0 ) {
				rcfile = malloc(strlen(resp)+1);
				strcpy(rcfile,resp);
			} else {
				rcfile = env;
			}
		}
	}

	/* .signature */
	signature = expand_filename(signature,home);
	
	/* author_copy */
	author_copy = expand_filename(author_copy,home);

#ifdef	SIGCONT
	signal(SIGCONT, foreground);
#endif

#ifdef	MSDOS
	if ( usrname == 0 ) {
		mc_puts("USER ˡ桼̾ꤷƲ\n");
		exit(1);
	}
	if ( fullname == 0 ) {
		mc_puts("NAME ˡ̾ꤷƲ\n");
		exit(1);
	}
	if ( genericfrom == 0 && hostname == 0 ) {
		mc_puts("HOST ˡУäΥۥ̾ꤷƲ\n");
		exit(1);
	}

	if ( auth(usrname) != 0 )	/* 桼ǧ */
		exit(1);

	while ( (pt = strchr(tmpdir,'/')) != NULL )
		*pt = SLASH_CHAR;

	while ( (pt = strchr(savedir,'/')) != NULL )
		*pt = SLASH_CHAR;

#else
	if ( (pt = getenv(ENVUSR)) == NULL && (pt = getenv(ENVUSR2)) == NULL ) {
		mc_puts("\n桼̾ǤޤǤ\n\007");
		hit_return();
		return(CONT);
	}
	usrname = pt;

	if ( (pw = getpwnam(usrname)) == NULL ){
		mc_puts("\nѥɥȥ꤬ǤޤǤ\n\007");
		hit_return();
		return(CONT);
	}

	if ( fullname == 0 ) {
		pt = (unsigned char *)pw->pw_gecos;
		sp = full_name;
		while (*pt != '\0' && *pt != ',' && *pt != ';' && *pt != '%') {
			if (*pt == '&') {
				strcpy(sp, usrname);
				if ( 'a' <= *sp && *sp <= 'z' )
					*sp = *sp - 'a' + 'A';
				while (*sp != '\0')
					sp++;
				pt++;
			} else {
				*sp++ = *pt++;
			}
		}
		*sp = 0;
		fullname = malloc(strlen(full_name)+1);
		strcpy(fullname,full_name);
	}
	if ( hostname == 0 ) {
		/* hostname  domainname ĤƤϡ */
		if ( gethostname(host_name,MAXHOSTNAME) != 0 ) {
			mc_puts("\nۥ̾ǤޤǤ\n\007");
			exit(1);
		}
		hostname = malloc(strlen(host_name)+1);
		strcpy(hostname,host_name);
	}
#endif

	/* tmpdir ϥǥ쥯ȥǤʤФʤʤ */
	if ( stat(tmpdir,&stat_buf) != 0 ) {
		mc_puts("ƥݥǥ쥯ȥȤƻꤵƤ ");
		printf("%s",tmpdir);
		if ( mkdir(tmpdir,0775) != 0 ) {	/* boooom */
			mc_puts(" 뤳ȤǤޤ\n");
			perror(tmpdir);
			exit(1);
		} else {
			mc_puts(" ¸ߤʤäᡢޤ\n");
		}
	} else { 
		if ( (stat_buf.st_mode & S_IFMT) != S_IFDIR ) {		/* S_IFLNK  ? */
			mc_puts("ƥݥǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ\n");
			/* 㤡ǥ쥯ȥϤ¥ */
			exit(1);
		}
	}

	/* tmpdir κǸ / ǽ褦ˤ */
	if ( tmpdir[strlen(tmpdir)-1] != SLASH_CHAR ) {
		pt = malloc(strlen(tmpdir)+2);
		strcpy(pt,tmpdir);
		strcat(pt,SLASH_STR);
		free(tmpdir);
		tmpdir = pt;
	}

	/* savedir Ÿ */
	pt = expand_filename(savedir,"$HOME");
	if ( pt == 0 ) {
		mc_puts("ե̾Ÿ˼Ԥޤ\n");
		hit_return();
		exit(1);
	}
	free(savedir);
	savedir = pt;

	/* savedir ϥǥ쥯ȥǤʤФʤʤ */
	if ( stat(savedir,&stat_buf) == 0 ) {
		if ( (stat_buf.st_mode & S_IFMT) != S_IFDIR ) {		/* S_IFLNK  ? */
			mc_puts("¸ǥ쥯ȥȤƥǥ쥯ȥʳꤵƤޤ\n");
			/* 㤡ǥ쥯ȥϤ¥ */
			exit(1);
		}
	}

	/* savedir κǸ / ǽ褦ˤ */
	if ( savedir[strlen(savedir)-1] != SLASH_CHAR ) {
		pt = malloc(strlen(savedir)+2);
		strcpy(pt,savedir);
		strcat(pt,SLASH_STR);
		free(savedir);
		savedir = pt;
	}

	/* domainname, organization ϥޥƤʤФʤʤ */
	if (strcmp(domainname,"your.domain.name") == 0 ) {
		mc_puts("ɥᥤ̾ꤵƤޤ\n");
		exit(1);
	}
	if ( strcmp(organization,"your organization") == 0 ) {
		mc_puts("ȿ̾ꤵƤޤ\n");
		exit(1);
	}

	return(check_only);
}

#ifdef	SIGWINCH
static
resize_window()
{
	struct winsize buf;

	if (ioctl (0, TIOCGWINSZ, &buf) < 0)
		return;
	if ( buf.ws_row != 0 )
		lines = buf.ws_row;
	if ( buf.ws_col != 0 )
		columns = buf.ws_col;

	if ( redraw_func != (int (*)())NULL)
		redraw_func();

	signal(SIGWINCH, resize_window);
}
#endif

#ifdef	SIGCONT
static int
foreground()
{
	if ( redraw_func != (int (*)())NULL)
		redraw_func();

	signal(SIGCONT, foreground);
}
#endif

static void
read_gnrc(gnrc)
register unsigned char *gnrc;
{
	register unsigned char *pt;
	FILE *fp;
	struct stat stat_buf;
	unsigned char resp[NNTP_STRLEN+1];
	register struct env_t *env_tp;
	register struct gnrc_t *gnrc_tp;

	if ( stat(gnrc,&stat_buf) != 0 )
		return;

	if ( (fp = fopen(gnrc,"r")) == NULL )
		return;

	printf("reading %s\n",gnrc);

	while ( fgets(resp,NNTP_STRLEN,fp) != NULL ) {
		if ( (pt = strchr(resp,'\n')) !=NULL )
			*pt = 0;
		pt = &resp[0];
		while ( *pt == ' ' || *pt == '\t' )
			pt++;		/* Ԥۥ磻ȥڡ̵ */
		if ( *pt == 0 )
			continue;	/* ۥ磻ȥڡΤ */
		if ( *pt == '#' )
			continue;
		while ( *pt != 0 && *pt != ' ' && *pt != '\t' )
			pt++;
		if ( *pt == 0 ) {	/* value ʤ */
			printf(gnrc);
			mc_puts(" ʹԤޤ:");
			printf("%s\n",resp);
			continue;
		}
		*pt++ = 0;
		while ( *pt == ' ' || *pt == '\t' )
			pt++;		/* keyword  value δ֤Υۥ磻ȥڡ */
		if ( *pt == 0 ) {	/* value ʤ */
			printf(gnrc);
			mc_puts(" ʹԤޤ:");
			printf("%s\n",resp);
			continue;
		}

		/* Ķѿȶ̤:ʸ */
		for ( env_tp = &env_table[0] ; env_tp->str != 0 ; env_tp++ ) {
			if (strcmp(env_tp->str,resp) == 0 ) {
				if ( *(env_tp->value) != 0 )
					free(*(env_tp->value));
				*(env_tp->value) = malloc(strlen(pt)+1);
				strcpy(*(env_tp->value),pt);
				break;
			}
		}
		if ( env_tp->str != 0 )
			continue;

		/* gnrc ͭ: */
		for ( gnrc_tp = &gnrc_table[0] ; gnrc_tp->str != 0 ; gnrc_tp++ ) {
			if (strcmp(gnrc_tp->str,resp) == 0 ) {
				if ( '0' <= *pt && *pt <= '9' ) {
					*(gnrc_tp->value) = atoi(pt);
					break;
				}
				if ( strcmp(pt, "ON") == 0 || strcmp(pt, "YES") == 0 ) {
					*(gnrc_tp->value) = ON;
					break;
				}
				if ( strcmp(pt, "OFF") == 0 || strcmp(pt, "NO") == 0 ) {
					*(gnrc_tp->value) = OFF;
					break;
				}
				printf(gnrc);
				mc_puts("  ");
				printf(resp);
				mc_puts(" ˤϿꤷƲ\n");
				break;
			}
		}
		if ( gnrc_tp->str != 0 )
			continue;

		printf(gnrc);
		mc_puts(" ʥɤޤ:");
		printf("%s\n",resp);
	}
	
	fclose(fp);
}

/*
 * ˥塼Ф³
 */

open_server()
{
	int	response;

	if ( (response = server_init(nntpserver)) < 0 ) {
		printf("\n%s ",nntpserver);
		mc_puts("³ǤޤǤ\n");
		exit(1);
	}
	if ( handle_server_response(response,nntpserver) ){
		close_server();
		exit(2);
	}
}

/*
 * ƥ֥ե
 */
#define	C_GROUP	20

get_active(newsrc_flag)
int	newsrc_flag;	/* newsrc ɤ߹飰ʤäݣ */
{
#ifdef	SAVE_MEMORY
	FILE *sfp;
	unsigned char tmp[NEWSRC_LEN+1];
#endif
	newsgroup_t	**ng;
	unsigned char resp[NNTP_STRLEN+1];
	unsigned char *pt;
	long	first,last;
	register int	x = 0;
	register int	c_group = 0;

	mc_puts("\n̤ɤεƤޤ\n");

	put_server("LIST");
	if ( get_server(resp,NNTP_STRLEN))
		return(CONNECTION_CLOSED);
	if (atoi(resp) != OK_GROUPS ) {
		printf("\n%s\n",resp);
		exit(4);
	}

	while( 1 ) {
		if ( ++x > 20 ){
			printf(".");
			fflush(stdout);
			x = 0;
		}
		if ( get_server(resp,NNTP_STRLEN))
			connection_closed();
		if ( resp[0] == '.' )
			return(CONT);

		/* *resp : ˥塼롼̾ */
		if ( (pt = strchr(resp,' ')) == NULL )
			continue;
		*pt = 0;
		pt++;
		/* last : Ǹε */
		last = atol(pt);
		pt = strchr(pt,' ');
		pt++;
		/* first : ǽε */
		first = atol(pt);
		if ( last != 0 && first == 0 )
			first = 1;
		/* .newsrc 椫õ */
		for ( ng = &newsrc; ; ng = &((*ng)->next)) {
			if ( *ng == 0 ) {	/* .newsrc ˤϤʤ */
#ifdef	SAVE_MEMORY
				if ( (sfp = fopen(newsrc_tmp_file,"r")) == NULL ) {
					printf("\n%s ",newsrc_tmp_file);
					mc_puts("ߤĤޤ\n");
					return;
				}
				while ( fgets(tmp,NEWSRC_LEN,sfp) != NULL ) {
					if ( tmp[0] != resp[0] )
						continue;
					pt = strchr(tmp,'!');
					*pt = 0;
					if ( strcmp(tmp,resp) == 0 ) {	/* unsub ˤä */
						fclose(sfp);
						goto newsrc_end;
					}
				}
				fclose(sfp);
#endif
				if ( newsrc_flag == 0 ) {
					c_group++;
					if ( c_group == C_GROUP ) {
						mc_puts("̤Υ˥塼롼פ줿ΤǤʾɽޤ\n");
					} else if ( c_group < C_GROUP ) {
						mc_puts("\n˥塼롼 ");
						printf(resp);
						mc_puts(" ޤ\n");
					}
				}
				change = 1;
				*ng = (newsgroup_t *)malloc(sizeof(newsgroup_t));
				(*ng)->next = 0;
				(*ng)->newsrc = 0;
				(*ng)->name = malloc(strlen(resp)+1);
				(*ng)->desc = 0;
				strcpy((*ng)->name,resp);
				(*ng)->first = first;
				(*ng)->read = 0;
				(*ng)->numb = 0;
				(*ng)->last = last;
				(*ng)->flag = ACTIVE;
				(*ng)->subj = 0;

				/* control, junk, to.*  UNSUBSCRIBE ˤ */
				if (strcmp((*ng)->name,"control") == 0 ||
					strcmp((*ng)->name,"junk" ) == 0 ||
					strncmp((*ng)->name,"to.",3 ) == 0 ){
					(*ng)->flag |= UNSUBSCRIBE;
				}
				break;
			}
			if ( strcmp((*ng)->name,resp)== 0 ) {	/* ä */
				(*ng)->first = first;
				(*ng)->last = last;
				(*ng)->flag |= ACTIVE;
				break;
			}
		}
#ifdef	SAVE_MEMORY
	newsrc_end:
		;
#endif
	}
}
get_newsgroups()
{
	newsgroup_t *search_group();
	register newsgroup_t	*ng;
	unsigned char resp[NNTP_STRLEN+1];
	unsigned char resp2[NNTP_STRLEN+1];
	unsigned char *pt;
	register int	x = 0;

	mc_puts("\nƥ롼פ󤻤Ƥޤ\n");

	put_server("LIST NEWSGROUPS");
	if ( get_server(resp,NNTP_STRLEN))
		return(CONNECTION_CLOSED);
	if (atoi(resp) != OK_GROUPS ) {
		description = 0;
		printf("\n%s\n",resp);
		return(CONT);
	}

	while( 1 ) {
		if ( ++x > 20 ){
			printf(".");
			fflush(stdout);
			x = 0;
		}
		if ( get_server(resp,NNTP_STRLEN))
			connection_closed();
		if ( resp[0] == '.' )
			return(CONT);

		/* *resp : ˥塼롼̾ */
		pt = &resp[0];
		while ( *pt != ' ' && *pt != '\t' && *pt != 0 )
			pt++;
		if ( *pt == 0 )	/* ˥塼롼̾ʤ */
			continue;
		*pt++ = 0;
		while ( *pt == ' ' || *pt == '\t' )
			pt++;
		if ( *pt == 0 )	/* ˥塼롼̾ʤ */
			continue;

		if ( (ng = search_group(resp)) == 0 )	/* ˥塼롼פʤ */
			continue;
		kanji_fromspool(pt,resp2);	/* ǰΤᡢѴ */
		ng->desc = malloc(strlen(resp2)+1);
		strcpy(ng->desc,resp2);
	}
}

/*
 * ˥塼롼פΥå
 */

check_group(check_only)
int		check_only;
{
	unsigned char resp[NNTP_STRLEN+1];
	unsigned char *key_buf;
	register newsgroup_t **ng;
	register newsgroup_t *tmp;
	register int large_group = 0;

	ng = &newsrc;
	while(1) {
		if ( ((*ng)->flag & ACTIVE) != ACTIVE ) {
			/* ƥ֤Ǥʤ롼פϡ塼鳰 */
			tmp = (*ng); 
			*ng = (*ng)->next;
			printf("\n");
			mc_puts(tmp->name);
			mc_puts(" ϥƥ֤ǤϤޤ\n");
			free(tmp);
			change = 1;
		} else {
			/* Υ롼פΤߥå */
			if ( ((*ng)->flag & UNSUBSCRIBE) != UNSUBSCRIBE ) {
				if ( (*ng)->read < (*ng)->first )
					(*ng)->read = (*ng)->first - 1;
				if ( (*ng)->last < (*ng)->read )
					(*ng)->read = (*ng)->last;
			}
			/* ̤ɵ */
			if ( (*ng)->first < (*ng)->read + 1)
				(*ng)->numb = (*ng)->last - (*ng)->read;
			else
				(*ng)->numb = (*ng)->last - (*ng)->first + 1;

			/* GNUS եޥåȻ̤ɵ */
			if ( (*ng)->newsrc )
				newsrc_gnus_count(*ng);

			if ( (*ng)->numb < 0 )	/* ۾ newsrc ξΤ */
				(*ng)->numb = 0;

			/* ̤ɤε¿ϥå */
			if (((*ng)->flag & UNSUBSCRIBE) != UNSUBSCRIBE &&
				(*ng)->numb > article_limit ) {
				large_group = 1;
			}
			ng = &((*ng)->next);
		}
		if ( *ng == 0 )
			break;
	}

	/* ̤ɤε¿ϳǧ */
	if ( check_only == 0 && large_group == 1 ) {
		sprintf(resp,
				"\n̤ɤε%d¿ʤäƤ˥塼롼פޤ\n%d Ĥƾäޤ(y:ä/¾:Ĥ)",
			   article_limit,article_leave);
		key_buf = kb_input(resp);
		if ( *key_buf == 'y' || *key_buf == 'Y' )
			newsrc_kill_article();
	}
}

static void
newsrc_gnus_count(ng)
register newsgroup_t	*ng;
{
	register unsigned char *pt,*wk;
	register long st,ed;

	pt = ng->newsrc;
	while ( '0' <= *pt && *pt <= '9' ) {
		st = atol(pt);
		while ( '0' <= *pt && *pt <= '9' )
			pt++;
		switch ( *pt ) {
		case '-':		/* 999-999 */
			pt++;
			ed = atol(pt);
			while ( '0' <= *pt && *pt <= '9' )
				pt++;
			if ( *pt == ',' )
				pt++;
			/* **** */
			if ( ed <= ng->read || ed < ng->first ){
				if ( strlen(pt) != 0 ) {
					wk = malloc(strlen(pt)+1);
					strcpy(wk,pt);
					free(ng->newsrc);
					ng->newsrc = wk;
					pt = wk;
				} else {
					free(ng->newsrc);
					ng->newsrc = 0;
					return;
				}
				break;
			}
			if (ng->read < st && st <= ng->last &&
				ng->read < ed && ed <= ng->last) {
				ng->numb -= ( ed - st + 1);
			}
			break;
		default:		/* 999 */
			if ( *pt == ',' )
				pt++;

			if ( st <= ng->read || st < ng->first ){
				if ( strlen(pt) != 0 ) {
					wk = malloc(strlen(pt)+1);
					strcpy(wk,pt);
					free(ng->newsrc);
					ng->newsrc = wk;
					pt = wk;
				} else {
					free(ng->newsrc);
					ng->newsrc = 0;
					return;
				}
				break;
			}
			if (ng->read < st && st <= ng->last)
				ng->numb--;
			break;
		}
	}
}

/*
 * ʾεмΤƤ 
 */
static void
newsrc_kill_article()
{
	register newsgroup_t *ng;

	for ( ng = newsrc; ng != 0 ; ng=ng->next ) {
		/* ̤ɤϿʤ */
		if ( (ng->flag & UNSUBSCRIBE) == UNSUBSCRIBE )
			continue;
		/* ʲ */
		if ( ng->numb <= article_limit )
			continue;
		ng->read = ng->last - article_leave;
		ng->numb = article_leave;
		change = 1;
	}
}

static unsigned char *message_save;
static
kb_input_msg()
{
	mc_puts(message_save);
	fflush(stdout);
}
unsigned char *
kb_input(message)
unsigned char *message;
{
	static unsigned char key_buf[KEY_BUF_LEN];
	register unsigned char *pt;

	message_save = message;
	kb_input_msg();
	redraw_func = kb_input_msg;
	while ( fgets(key_buf,KEY_BUF_LEN,stdin) == NULL ) {
		clearerr(stdin);
		printf("\n");
		kb_input_msg();
	}
	redraw_func = (int (*)())NULL;

	/* Υۥ磻ȥڡä */
	pt = &key_buf[strlen(key_buf)-1];
	while( pt >= key_buf && ( *pt == ' ' || *pt == '\t' || *pt == '\n' ) )
		*pt-- = 0;

	/* Υۥ磻ȥڡä */
	pt = key_buf;
	while(*pt == ' ' || *pt == '\t' )
		pt++;
	return(pt);
}

hit_return()
{
	kb_input("\n꥿󥭡򲡤Ʋ");
	printf("\n");
}


unsigned char *
expand_filename(name,default_dir)
unsigned char *name;		/* Ϥ̾ */
unsigned char *default_dir;	/* / ϤޤʤΥǥեȥǥ쥯ȥ */
{
	unsigned char buf1[PATH_LEN],buf2[PATH_LEN],buf3[PATH_LEN];
	unsigned char *pt;
	unsigned char *path,*home;
	unsigned char *mae,*ato,*naka;

	/* Ԥۥ磻ȥڡ */
	pt = name;
	while ( *pt == ' ' || *pt == '\t' )
		pt++;

	/* ³ۥ磻ȥڡ˥塼饤 */
	ato = &pt[strlen(pt)-1];
	while ( *ato == ' ' || *ato == '\t' || *ato == '\n' )
		*ato-- = 0;

	mae = malloc(strlen(pt)+1);
	strcpy(mae,pt);
	pt = mae;

	while( 1 ) {
		/* ѿŸ */
		while ( (naka = strchr(pt,'$')) != 0 ){
			ato = naka + 1;
			while('A' <= *ato && *ato <= 'Z' || 'a' <= *ato && *ato <= 'z' ||
				  '0' <= *ato && *ato <= '9' || *ato == '_' )
				ato++;
			strcpy(buf3,ato);	/* $ 걦 */
			*ato = 0;
			strcpy(buf2,naka);	/* $Ȥ */
			*naka = 0;
			strcpy(buf1,pt);	/* $ 꺸 */
			free(pt);
			if ( (naka = getenv(&buf2[1]))== 0 )
				return(0);
			pt = malloc(strlen(buf1)+strlen(naka)+strlen(buf3)+3);
			strcpy(pt,buf1);
			strcat(pt,SLASH_STR);
			strcat(pt,naka);
			strcat(pt,SLASH_STR);
			strcat(pt,buf3);
			continue;
		}

		/* ~/ Ÿ */
		if ( *pt == '~' ) {
			if ( pt[1] == SLASH_CHAR ){
				home = getenv("HOME");
				path = malloc(strlen(pt)+strlen(home)+1);
				strcpy(path,home);
				strcat(path,SLASH_STR);
				strcat(path,&pt[1]);
				free(pt);
				pt = path;
				continue;
			}
		}

		/* //  / Ѵ */
#ifdef	apollo
		for ( mae = &pt[1] ; *mae ; mae++){
#else
		for ( mae = pt ; *mae ; mae++){
#endif
			while( 1 ) {
				if ( mae[0] == SLASH_CHAR  && mae[1] == SLASH_CHAR )
					strcpy(&mae[0],&mae[1]);
				else
					break;
			}
			continue;
		}

		/* ʸܤˤȽ */
#ifdef MSDOS
		for ( mae = pt ; *mae ; mae++){
			if ( mae[0] == '.' && strlen( mae ) > 4 )
				mae[0] = SLASH_CHAR;
		}
		if ( *pt != SLASH_CHAR && *(pt+1) != ':' ) {
			path = malloc(strlen(pt)+strlen(default_dir)+4);
			if ( *default_dir != SLASH_CHAR && *(default_dir+1) != ':' ){
				strcpy(path,SLASH_STR);
				strcat(path,default_dir);
			} else
				strcpy(path,default_dir);
			strcat(path,SLASH_STR);
#else
		if ( *pt != SLASH_CHAR ) {
			path = malloc(strlen(pt)+strlen(default_dir)+2);
			strcpy(path,default_dir);
			strcat(path,SLASH_STR);
#endif
			strcat(path,pt);
			free(pt);
			pt = path;
			continue;
		}
		return(pt);
	}
}
